<?php if (!defined('PmWiki')) exit();

/**

	PmWiki wbFAQ - adding a FAQ to PmWiki
	Written by (c) Bianka Martinovic

	This text is written for PmWiki; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published
	by the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version. See pmwiki.php for full details
	and lack of warranty.
	
	To use this recipe, simply copy it into the cookbook/ directory, and
  add the following line to a local customization:

        include_once("$FarmD/cookbook/WbFAQ.php");

	Copyright 2008, 2009 Bianka Martinovic  http://www.webbird.de

  PmWiki:
	Copyright 2004-2006 Patrick R. Michaud http://www.pmwiki.org
	
*/

global $InputAttrs;
global $EnableGUIButtons;

$lshow       = "$PubDirUrl/1downarrow.png";
$lhide       = "$PubDirUrl/1uparrow.png";
$catheadlink = "<img src=\"$PubDirUrl/2uparrow.png\" />";
$homelink    = "<img src=\"$PubDirUrl/top.png\" />";
$editlink    = "<img src=\"$PubDirUrl/kedit.png\" />";
$dellink     = "<img src=\"$PubDirUrl/delete.png\" />";
$movelink    = "<img src=\"$PubDirUrl/move.png\" />";

// workaround for PHP4
if ( ! function_exists('htmlspecialchars_decode') ) {

    $eval_func =
    'function htmlspecialchars_decode($string,$style=ENT_COMPAT)
    {
        $translation = array_flip(get_html_translation_table(HTML_SPECIALCHARS,$style));
        if($style === ENT_QUOTES){ $translation[\'&#039;\'] = \'\\\'\'; }
        return strtr($string,$translation);
    }
    ';
    $ret = eval (
        $eval_func
    );
}

// make this work with PmWiki 2.2.0
$temp = explode( '-', $Version );
if ( $temp[1] < "2.2.0" ) {
    include_once('WbFAQ/forms.php');
}
else {
    if ( IsEnabled($EnableGUIButtons,0) ) {
        include_once("$FarmD/scripts/guiedit.php");
    }
    include_once("$FarmD/scripts/forms.php");
}

// add the onchange event to input fields
$InputAttrs[] = 'onchange';

SDV( $RecipeInfo['wbFAQ']['Version'], '2009-11-02' );

$FmtPV['$wbFAQVersion']
    = Keep( "wbFAQ-{$RecipeInfo['wbFAQ']['Version']}" );

global $debug;
$debug = false;
#$debug = true;
if ( true === $debug ) {
  	ini_set('display_errors', 1);
  	error_reporting(E_ALL);
}

/***********************************************************************
   wbFAQ configuration

   Do NOT set this variables here! These are defaults. You can set
   (override) them in your (farm)config.php!

   Example (config.php):

   $wbFAQAuthLevel = 'read';

*/

// toggle categories, too; defaults to 'no'
// valid values:
//    enable  - 'on', '1', 'y'
//    disable - 'off' - or any other value like false, 0, ...
SDV(
    $wbFAQCategoryToggle,
    'off'
);

// auto hide answers
// this is used to show the complete FAQ if JavaScript is disabled
// valid values:
//    enable  - 1
//    disable - 0 or any other value <> 1
SDV(
    $wbFAQAutoHide,
    1
);

// show question list
// creates a list of all questions at the beginning of the page
// valid values:
//    enable  - 'show'
//    disable - any other value
SDV(
    $wbFAQQuestListShow,
    'show'
);

// auto hide question list
// close list of questions automatically if $wbFAQQuestListShow is
// set to 'show'
// valid values:
//    enable  - 'hide'
//    disable - 'show'
// (values accepted by the ToggleLink JavaScript)
SDV(
    $wbFAQQuestListInitState,
    'hide'
);

// input form page name
// this page is included in the ZIP; feel free to use another page
// for your input
// but: handle with care!
SDV(
    $wbFAQEditForm,
    'WbFAQ.InputForm'
);

// required user level for posting
// this overrides the settings made in (farm)config.php or
// GroupAttributes page
SDV(
    $wbFAQAuthLevel,
    'admin'
);

// file to store category list in
// all categories for all page groups are stored in one category
// file, which is hidden by default (on UNIX/LINUX systems)
SDV(
    $wbFAQCatFile,
    "$WorkDir/.wbFAQcategories"
);

// file to store faq index in
// all faq entries* for all page groups are stored in one
// file, which is hidden by default (on UNIX/LINUX systems)
//
// * this means "entry information" is stored there. the entry itself
//   is stored in a wiki page!
SDV(
    $wbFAQIndexFile,
    "$WorkDir/.wbFAQ"
);

/***********************************************************************
 * please do NOT edit anything below this line if you don't really
 * REALLY know for sure what you are doing!
 **********************************************************************/

/***********************************************************************
 * output formatting
 */

// toggle text; translations in PmWiki<lang>.XLPage!
SDV(
    $wbFAQToggleText,
    array(
        '$[hide table of contents]',
        '$[show table of contents]'
    )
);

SDV(
    $wbFAQHomeLinkText,
    'Go to top'
);

SDV(
    $wbFAQCatHeaderLinkText,
    'Go to category top'
);

// question list begin
SDV(
    $wbFAQQuestListFmt,
      "[[#top]]\n\n"
    . "\n(:toggle div='_tog_questlist_\$group' lshow='$wbFAQToggleText[1]' lhide='$wbFAQToggleText[0]' init=$wbFAQQuestListInitState:)\n"
    . "\$_faq_toggle_group"
    . "\n>>id=\"_tog_questlist_\$group\" class=wbfaqquestlist<<\n"
    . "\$_faq_quest_list\n"
    . ">><<\n"
    . ">><<\n"
);

// question list category format
SDV(
    $wbFAQQuestListCatFmt,
    "\n\n* \$category\n"
);

// question list item format
SDV(
    $wbFAQQuestListItemFmt,
    "** \$_faq_question\n"
);

// category header
SDV(
    $wbFAQCategoryFmt,
    "\n!!! [[#top_\$catid]]\$category\n"
);

// category header with toggle
SDV(
    $wbFAQCategoryToggleFmt,
    "!!!(:toggle div=\$divid lshow='$lshow' lhide='$lhide' init=\$init:) [[#top_\$catid]]\$category\n"
  . "(:\$divid id=\$divid:)\n"
);

// question
SDV(
    $wbFAQQuestionFmt,
    "[[#\$anchorid]]"
  . "(:toggle div=\$divid lshow='$lshow' lhide='$lhide':)"
  . "'''\$_faq_question'''\\\\\n"
);

// answer
SDV(
    $wbFAQAnswerFmt,
    "\n>>id=\$divid class=wbfaqanswer<<\n"
  . "\$_faq_answer\\\\\n"
  . "\$uplink \$homelink (:if auth {$wbFAQAuthLevel}:)\$_faq_edit_link(:ifend:)\n"
  . ">><<\n\\\\\n"
);

/***********************************************************************
 * Page variables (faq input form)
 */

$FmtPV['$wbFAQGroup']      = '';
$FmtPV['$wbFAQCategories'] = '';
$FmtPV['$wbFAQPage']       = '';

$EditFields = array( 'text', '_faq_category', '_faq_question', '_faq_answer' );
$nl         = array( "\r\n", "\n", "\r");

/***********************************************************************
 * Action handlers
 */

SDVA( $HandleActions,
      array(
          'wbpostfaq'    => 'wbFAQPost',
          'wbfaqadmin'   => 'wbFAQAdmin'
      )
);
SDVA( $HandleAuth,
      array(
          'wbpostfaq'    => $wbFAQAuthLevel,
          'wbfaqadmin'   => $wbFAQAuthLevel,
      )
);

$HTMLHeaderFmt[] =
  "<link rel='stylesheet' href='\$PubDirUrl/css/wbfaq.css' type='text/css' />";

/***********************************************************************
 * Markups
 */

Markup(
    'wbfaqform',
    'inline',
    '/\\(:wbfaqform\\s*(.*?):\\)/e',
    "Keep(wbFAQForm('$pagename', '$1'),'')"
);

Markup(
    'wbfaqshow',
    'block',
    '/\\(:wbfaqshow([^:]*):\\)/sei',
    "wbFAQShow('$pagename', '$1')"
);



$find_vars = array(
    '$divid',
    '$anchorid',
    '$uplink',
    '$homelink',
    '$_faq_question',
    '$_faq_answer',
    '$_faq_edit_link'
);

$wbFAQAutoHideJS = "
<script type=\"text/javascript\">
    function isImage(sValue)
    {
        var aParts   = sValue.split( \"/\" );
        var iParts   = aParts.length;
        var suffixes = Array( '" . implode('\', \'',array( 'jpg', 'jpeg', 'gif', 'png' )) . "' );
        if( iParts >= 1 )
        {
            var sFile = aParts[ iParts - 1 ];
            var aFile = sFile.split( \".\" );
            if( aFile.length == 2 )
            {
                for( var i in suffixes )
                {
                    if ( aFile[1] == suffixes[i] )
                    {
                        return true;
                    }
                }
            }
            else
            {
              return false;
            }
        }
    }
    function autoHide() {
        var wbDivs = document.getElementsByTagName('div');
        for ( var i=0; i<wbDivs.length; i++ ) {
            if ( wbDivs[i].className == 'wbfaqanswer'
              || wbDivs[i].id.substr( 0, 3 ) == 'div' ) {
                var elstyle = wbDivs[i].style;
                elstyle.display = 'none';
                var showlink = '".$lshow."';
                if ( isImage('".$lshow."') ) {
                    showlink = '<img src=\"".$lshow."\" />';
                }
                if ( isImage('".$lhide."') ) {
                    hidelink = '<img src=\"".$lhide."\" />';
                }
                copy='<a class=\"wikilink\" ';
                copy+='href=\"javascript:toggleObj(\''+wbDivs[i].id+'\',\'show\',\'".$lshow."\',';
                copy+= '\'".$lhide."\',\'\',\'0\',\'\');\">'+showlink+'</a>';
                var text = document.getElementById(wbDivs[i].id + \"-tog\");
                text.innerHTML = copy;
            }
        }
    }
    autoHide();
</script>
";

/***********************************************************************
 * wbFAQShow - show the faq
 *
 *  args:    pagename, arguments
 *  returns: faq
 *
 */
function wbFAQShow ( $pagename, $args )
{
    global $find_vars,
           $PubDirUrl,
           $wbFAQAuthLevel,
           $wbFAQCategoryToggle,
           $wbFAQQuestListHideAuto,
           $wbFAQQuestListShow,
           $wbFAQQuestListFmt,
           $wbFAQQuestListCatFmt,
           $wbFAQQuestListItemFmt,
           $wbFAQCategoryFmt,
           $wbFAQCategoryToggleFmt,
           $wbFAQQuestionFmt,
           $wbFAQAnswerFmt,
           $wbFAQAutoHide,
           $wbFAQAutoHideJS,
           $lshow,
           $lhide,
           $homelink,
           $editlink,
           $catheadlink,
           $wbFAQHomeLinkText,
           $wbFAQCatHeaderLinkText,
           $HTMLFooterFmt;

    // if the group name(s) seem to be wiki words, they are "masked"
    // by $KeepToken
    global $KeepToken;
    $args = preg_replace( "/$KeepToken(\\d.*?)$KeepToken/e", '$GLOBALS[\'KPV\'][\'$1\']', $args );

    $args     = ParseArgs($args);
    $groups   = array();
    $showcats = array();
    $output   = array();
    $quest    = array();
    $num      = 0;
    $divnum   = 0;

    $output[] = "(:if auth $wbFAQAuthLevel:)%rfloat%"
              . Keep( "<a href=\"?n=$pagename&amp;action=wbfaqadmin&amp;_faq_action=\">FAQ Admin</a>" )
              . "%%(:ifend:)\n";

    if ( isset( $args['groups'] ) )
    {
        $groups = explode( ',', $args['groups'] );
    }
    if ( isset ( $args['group'] ) )
    {
        $groups[] = $args['group'];
    }
    if ( isset ( $args['categories'] ) )
    {
        $showcats = explode( ',', $args['categories'] );
    }

    // group defaults to current group
    if ( ! is_array( $groups ) || count( $groups ) == 0 )
    {
        $pieces   = preg_split( "/\.|\//", $pagename);
        $groups[] = $pieces[0];
    }

    foreach ( $groups as $group )
    {

        // create anchor
        $output[] = "[[#top_$group]]\n";

        // sort categories
        $categories = __sort2d( __wbFAQReadCategories( $group ), 1, 'asc', true );

        foreach ( $categories as $cat )
        {

            // remove everything but letters and numbers
            $catid = ereg_replace( "[^A-Za-z0-9]", "", $cat[3] );
            // all to lowercase
            $catid = strtolower($catid);

            if ( count( $showcats ) > 0 )
            {
                $show = array_search( $cat[3], $showcats );
                if ( is_int( $show ) )
                {
                    continue 1;
                }
            }

            // if category toggle is 'on', we create (:toggle:) markups
            // for each catory
            if ( $wbFAQCategoryToggle === 'on'
              || $wbFAQCategoryToggle === '1'
              || $wbFAQCategoryToggle === 'y'
            ) {

                // unify the option value for later use
                $wbFAQCategoryToggle = 'on';

                // create a unique div id
                $divid               = 'div'.$divnum;

                // create the toggle
                $category_header = str_replace(
                    array(
                        '$catid',
                        '$category',
                        '$divid',
                        '$init'
                    ),
                    array(
                        $catid,
                        $cat[3],
                        $divid,
                        'show'
                    ),
                    $wbFAQCategoryToggleFmt
                );

            } else {
                // simple heading
                $category_header = str_replace(
                   array(
                      '$catid',
                      '$category'
                   ),
                   array(
                       $catid,
                       $cat[3]
                   ),
                   $wbFAQCategoryFmt
                );
            }

            $output[] = $category_header;
            $quest[]  = str_replace( '$category', $cat[3], $wbFAQQuestListCatFmt );

            // get the pages for the current category
            $pages    = __sort2d( __wbFAQReadIndex( $group, $cat[3] ), 1, 'asc', true );

            // no pages found, skip
            if ( ! is_array( $pages ) )
            {
                continue;
            }

            $last_id = end($pages);
            $last_id = $last_id[4];
            reset($pages);

            foreach ( $pages as $page )
            {

                // create unique div id for this question
                $id      = 'div_'.substr( $page[4], -6 );

                // get page contents
                $current = ReadPage( $page[4] );

                // create replacements array for use with str_replace
                $replace = array(
                                    strtolower($id),
                                    strtolower($page[4]),
                                    __wbFAQToggleLink( '#top_'.$catid, $id, 'hide', $catheadlink, $wbFAQCatHeaderLinkText ),
                                    __wbFAQToggleLink( '#top', $id, 'hide', $homelink, $wbFAQHomeLinkText ),
                                    $current['_faq_question'],
                                    $current['_faq_answer'],
                                    __wbFAQToggleLink( '?n='.$page[4], $id, 'show', $editlink, 'edit', '_new' ),
                                );

                // create the entry
                $quest[]
                    = str_replace(
                          array(
                              '$anchorid',
                              '$_faq_question'
                          ),
                          array(
                              strtolower($page[4]),
                              __wbFAQToggleLink( '#'.strtolower($page[4]), $id, 'show', $current['_faq_question'] ),
                          ), $wbFAQQuestListItemFmt
                    );

                $output[] = str_replace(
                                $find_vars,
                                $replace,
                                $wbFAQQuestionFmt
                            );
                $output[] = str_replace(
                                $find_vars,
                                $replace,
                                $wbFAQAnswerFmt
                            );

                $num++;

                if ( $page[4] === $last_id && $wbFAQCategoryToggle === 'on' ) {
                    $output[] = Keep( "<a href=\"#top\" title=\"$wbFAQHomeLinkText\" "
                                    . "onclick=\"javascript:toggleObj('div$divnum','hide','$lshow','$lhide','',0,'');"
                                    . "return true;\">$homelink</a>\n" );
                }

            }

            if ( $wbFAQCategoryToggle === 'on' ) {
                $output[] = "\n(:div".$divnum."end:)\n";
                $divnum++;
            }
            else {
                // add link to cat header
                $output[] = Keep( "<a href=\"#top_$catid\" title=\"$wbFAQCatHeaderLinkText\">$catheadlink</a>" );
                // add link to FAQ top
                $output[] = Keep( "<a href=\"#top\" title=\"$wbFAQHomeLinkText\">$homelink</a>\n" );
            }

        }

    }

    $return = '';

    $pieces = preg_split( "/\.|\//", $pagename);
    $group  = strtolower( $pieces[0] );

    if ( $wbFAQQuestListShow == 'show' )
    {
        $return = str_replace(
                  array(
                      '$group',
                      '$_faq_quest_list',
                      '$_faq_toggle_group'
                  ),
                  array(
                      $group,
                      implode( '', $quest ),
                      "{$wbFAQToggleText[0]}"
                  ),
                  $wbFAQQuestListFmt
              );
    }

    $return .= implode( '', $output );

    if ( $wbFAQAutoHide == 1 ) {
        $HTMLFooterFmt['wbfaq'] = $wbFAQAutoHideJS;
    }

    return MarkupToHtml( $pagename, FmtPageName( $return, $pagename ) );
    #return FmtPageName( $return, $pagename );

}   // function wbFAQShow

/***********************************************************************
 * wbFAQForm - returns the faq input form
 *
 *  args:    pagename, arguments
 *  returns: faq input form
 *
 */
function wbFAQForm ( $pagename, $args )
{
    global $FmtPV, $debug, $wbFAQEditForm, $wbFAQGroup, $InputValues;

    $args   = ParseArgs($args);
    $values = array();

    if ( true === $debug ) {
        echo "[WbFAQForm]<br />\n",
             "FAQEditForm: $wbFAQEditForm<br />\n";
        echo "<pre>";
        print_r($args);
        echo "</pre>";
    }

    // group defaults to current group
    if ( ! isset( $args['group'] ) )
    {
        $pieces        = preg_split( "/\.|\//", $pagename);
        $args['group'] = $pieces[0];
    }

    $FmtPV['$wbFAQGroup'] = $args['_faq_group'];

    // existing item selected?
    if ( isset ( $args['item'] ) && PageExists( $args['item'] ) )
    {
        $values = ReadPage( $args['item'] );
        while ( list( $key, $value ) = each ($values) )
        {
            $InputValues[$key] = htmlspecialchars($value);
        }
        $InputValues['_faq_page']  = $args['item'];
        $InputValues['_faq_group'] = $args['group'];
    }

    // category select
    $categories = __wbFAQReadCategories( $args['group'] );

    $output = '<select name="_faq_category">';
    foreach ( $categories as $cat )
    {
        $selected = '';
        if ( isset( $values['_faq_category'] )
          && $values['_faq_category'] === $cat[3] )
        {
            $selected = 'selected="selected"';
        }
        $output .= "<option value=\"$cat[3]\" $selected>$cat[3]</option>";
    }
    $FmtPV['$wbFAQCategories'] = Keep( $output . '</select>' );

    if ( PageExists($wbFAQEditForm) )
    {
        $page = ReadPage( $wbFAQEditForm );
        return MarkupToHTML( $pagename, FmtPageName( $page['text'], $pagename ) );
    }
    else
    {
        if ( true === $debug )
        {
            echo "page $wbFAQEditForm not found<br />\n";
        }
    }

    return;
}   // function wbFAQForm

/***********************************************************************
 * wbFAQPost - save the faq entry
 *
 *  args:    pagename, current auth level
 *  returns: nothing
 *
 */
function wbFAQPost ( $pagename, $auth = 'read' )
{
    global $HandleAuth, $wbFAQAuthLevel, $wbFAQIndexFile;

    // override the default from config setting
    $HandleAuth['wbpostfaq'] = $wbFAQAuthLevel;

    $page = RetrieveAuthPage( $pagename, $auth );

	  if ( ! $page ) {
		    Abort("?you are not permitted to perform this action");
		    return;
    }

    $cat    = $_REQUEST['_faq_category'];

    // group defaults to current group
    if ( $group == '' )
    {
        $pieces = preg_split( "/\.|\//", $pagename);
        $group  = $pieces[0];
    }

    if ( isset ( $_REQUEST['_faq_page'] ) && ! empty( $_REQUEST['_faq_page'] ) )
    {
        $new_page_name = $_REQUEST['_faq_page'];
    }
    else
    {
        $base   = MakePageName( $group, 'FAQ-' );
        $length = strlen($base);

        foreach ( ListPages( "/^$base\\d{6}$/" ) as $i )
        {
            $id = max( @$id, substr($i, $length + 1) );
        }
        $id++;

        $new_page_name = MakePageName( $pagename, sprintf( 'FAQ-' . "%06d", $id ) );
    }

    // Update index
    $args = array(
        group    => $group,
        cat      => $cat,
        page     => $new_page_name,
        question => $_REQUEST['_faq_question'],
    );
    __wbFAQUpdateIndex ( $wbFAQIndexFile, $args );

    $_POST['_faq_category'] = $cat;
    $_POST['_faq_question'] = $_REQUEST['_faq_question'];
    $_POST['_faq_answer']   = $_REQUEST['_faq_answer'];
    $_POST['text']          = "(:wbfaqform group=$group item=$new_page_name:)\n"
                            . '!' . $_REQUEST['_faq_question']
                            . "\n"
                            . $_REQUEST['_faq_answer'];

    HandleEdit($new_page_name, $wbFAQAuthLevel);

}   // function wbFAQPost


/**
 * wbFAQAdmin - manage FAQ entries
 *
 *  args:    pagename, current auth level
 *  returns: nothing
 *
 */
function wbFAQAdmin ( $pagename, $auth = 'read' )
{
    global $HandleAuth,
           $wbFAQAuthLevel,
           $PubDirUrl,
           $PageStartFmt,
           $PageEndFmt,
           $wbFAQIndexFile,
           $wbFAQCatFile;

    $output = array();

    $HandleAuth['wbfaqadmin'] = $wbFAQAuthLevel;

    $page = RetrieveAuthPage( $pagename, $auth );

	  if ( ! $page ) {
		    Abort("?you are not permitted to perform this action");
		    return;
    }

    // get current page group
    if ( isset( $_REQUEST['_faq_group'] ) )
    {
        $group = $_REQUEST['_faq_group'];
    }
    else
    {
        $pieces = preg_split( "/\.|\//", $pagename);
        $group  = $pieces[0];
    }

    // store new category
    if ( isset( $_POST['_faq_addcat'] ) )
    {
        if ( isset( $_POST['_new_cat_name'] ) )
        {
            $args = array(
                group    => $group,
                cat      => $_POST['_new_cat_name']
            );
            __wbFAQUpdateIndex ( $wbFAQCatFile, $args );
        }
        else
        {
            return __wbFAQCatForm( $group );
        }
    }

    // load categories
    $categories  = __sort2d( __wbFAQReadCategories( $group ), 1, 'asc', true );

    $cur_entries = NULL;
    $cur_cats    = NULL;

    if ( isset( $_REQUEST['_faq_action'] ) ) {

        switch ( $_REQUEST['_faq_action'] ) {

            case 'editcat':
                $cur_cats = '%current%';
                $output   = __wbFAQEditCat ( $pagename, $categories, $group, $args );
                break;

            case 'addentry':
                $output[] = Keep( WbFAQForm( $pagename, "group=$group" ) );
                break;

            default:
                $cur_entries = '%current%';
                $output   = __wbFAQEditEntries( $pagename, $group, $categories, $args, $auth );
            	 	break;
        }

    }

    // add navigation header
    $output = array_merge(
        array(
            "(:div id=navcontainer:)\n",
            "* $cur_entries [[$pagename?action=wbfaqadmin&amp;_faq_action=&amp;_faq_group=$group | \$[Edit Entries] ]]\n",
            "* $cur_cats [[$pagename?action=wbfaqadmin&amp;_faq_action=editcat | \$[Edit Categories] ]]\n",
            "(:divend:)\n"
        ),
        $output
    );


    PrintFmt(
        $pagename,
        array(
            &$PageStartFmt,
            MarkupToHTML( $pagename, implode( '', $output ) ),
            &$PageEndFmt
        )
    );

}


/***********************************************************************
 * INTERNAL FUNCTIONS
 **********************************************************************/

/***********************************************************************
 * __wbFAQCatForm - add new category
 */
function __wbFAQCatForm ( $group = '' )
{
    global $pagename, $PageStartFmt, $PageEndFmt;
    $output = array();

    if ( $group == '' )
    {
        $pieces = preg_split( "/\.|\//", $pagename);
        $group  = $pieces[0];
    }

    array_push(
        $output,
        "!$[Add category]\n",
        "(:input form action={\$PageUrl}:)\n",
        "(:input hidden action wbfaqadmin:)\n",
        "(:input hidden _faq_addcat 1:)\n",
        "(:input hidden _faq_group $group:)\n",
        "$[Category]: (:input text _new_cat_name :)\n",
        "(:input submit name=post value=\"$[Save]\" class=wbfaqbutton:)\n",
        "(:input end:)\\\\\n"
    );

    PrintFmt(
        $pagename,
        array(
            &$PageStartFmt,
            MarkupToHTML( $pagename, implode( '', $output ) ),
            &$PageEndFmt
        )
    );
}   // function __wbFAQCatForm

/***********************************************************************
 * __wbFAQReadCategories - read category list
 *
 *   Format:
 *   Array
 *  (
 *    [0] => Array
 *         (
 *             [0] =>
 *             [1] => 1
 *             [2] => FAQ
 *             [3] => Glossar
 *             [4] =>
 *
 *         )
 *
 */
function __wbFAQReadCategories ( $group = '([^:].*)' )
{
    global $wbFAQCatFile, $pagename;

    $categories = array();

/*
    if ( $group == '' )
    {
        $pieces = explode( '.', $pagename );
        $group  = $pieces[0];
    }
*/

    $file   = getcwd()."/$wbFAQCatFile";
//echo "<!-- FILE: $file -->\n";

    if ( file_exists( $file ) )
    {
        $handle = fopen( $file, 'r' );
        while ( ! feof($handle) )
        {

            $line  = fgets($handle, 4096);

            // line format:
            // ::<sort order>::<group>::<category name>::
            if ( preg_match( "/^::(\d+)::$group::.*/", $line, $matches ) )
            {
                $categories[] = explode( '::', $line );
            }

        }
        fclose( $handle );
    }

    $categories = __sort2d( $categories, 1, 'asc' );

    return $categories;

}   // function __wbFAQReadCategories

/***********************************************************************
 * __wbFAQSortCatIndex - sort category index entries
 */
function __wbFAQSortCatIndex ()
{
    global $wbFAQCatFile;

    $group = $_REQUEST['group'];
    $id    = $_REQUEST['id'];

    if ( $group == '' )
    {
        $pieces = preg_split( "/\.|\//", $pagename);
        $group  = $pieces[0];
    }

    $new_id;
    $changes = array();

    if ( ! empty ( $_REQUEST['up'] ) )
    {
        $find_cat = $_REQUEST['up'];
        $new_id   = $id - 1;
    }
    elseif ( ! empty ( $_REQUEST['down'] ) )
    {
        $find_cat = $_REQUEST['down'];
        $new_id    = $id + 1;
    }
    else
    {
        return;
    }

    $categories = __wbFAQReadCategories( $group );

    while ( list ( $index, $item ) = each( $categories ) )
    {
        if ( $item[3] === $find_cat )
        {
            $changes[$index] = $new_id;
        }
        elseif ( $item[1] == $new_id )
        {
            $changes[$index] = $id;
        }
    }

    while ( list ( $index, $id ) = each( $changes ) )
    {
        // Update index
        $args = array(
            group    => $group,
            cat      => $categories[$index][3],
            order    => $id
        );
        __wbFAQUpdateIndex ( $wbFAQCatFile, $args );
    }
}

/***********************************************************************
 * __wbFAQReadIndex - read FAQ pagelist
 */
function __wbFAQReadIndex ( $group = '', $cat = '' )
{
    global $wbFAQIndexFile, $pagename;
    $pagelist = array();

/*
    if ( $group == '' )
    {
        $pieces = explode( '.', $pagename );
        $group  = $pieces[0];
    }
*/

    $file   = getcwd()."/$wbFAQIndexFile";

    if ( ! file_exists( $file ) )
    {
        return;
    }

    $handle = fopen( $file, 'r' );

    if ( $handle ) {

        while ( ! feof($handle) ) {

            $line  = fgets($handle, 4096);

            if ( ! empty ( $line ) )
            {
                if ( preg_match( "{^::(\d+)::$group::$cat.*}", $line ) ) {
                    $pagelist[] = explode( '::', $line );
                }
            }
        }

        fclose( $handle );

    }

    return $pagelist;

}   // function __wbFAQReadIndex


/***********************************************************************
 * __wbFAQUpdateIndex - update index file
 */
function __wbFAQUpdateIndex ( $file = '', $args = array() )
{
    global $pagename, $debug, $wbFAQCatFile;

    $group = $args['group'];
    $cat   = $args['cat'];

    if ( $group == '' )
    {
        $pieces = preg_split( "/\.|\//", $pagename);
        $group  = $pieces[0];
    }

    if ( isset( $args['page'] ) ) // reorder pages
    {
        $page = $args['page'];
        $regexp  = "{^::(\d+)::$group::([^:]*)::$page::}";
        $eval    = '$newline = "::$order::$group::$cat::$page::".$args[\'question\']."::\n";';
    }
    elseif( isset( $args['newgroup'] ) ) {
        $regexp  = "{^::(\d+)::$group::([^:]*)::".$args['move']."::([^:]*)::}";
        $eval    = '$newline = "::0::'.$args['newgroup'].'::$cat::'.$args['move'].'::$question::\n";';
    }
    else {                        // reorder categories
        $regexp  = "{^::(\d+)::$group::$cat::}";
        $eval    = '$newline = "::$order::$group::$cat::\n";';
    }

    $file   = getcwd()."/$file";
    $mode   = 'w';
    $append = 0;
    $lines  = array();
    $i      = 0;

    if ( file_exists( $file ) )
    {
        $mode   = 'r+';
        $append = 1;
    }

    $handle = fopen( $file, $mode );
    $found;

    if ( $handle ) {

        if ( $append == 1 )
        {
            while ( ! feof($handle) ) {

                $line  = fgets($handle, 4096);

                if ( ! empty ( $line ) )
                {
                    if ( preg_match( $regexp, $line, $matches ) )
                    {

                        $found++;

                        if ( isset( $args['move'] ) ) {

                            $cat      = $matches[2];
                            $question = $matches[3];

                            // find if category exists in new group
                            $categories = __wbFAQReadCategories( $_REQUEST['destgroup'] );

                            if ( ! in_array( $cat, $categories ) ) {
                                $args = array(
                                    group    => $_REQUEST['destgroup'],
                                    cat      => $cat
                                );
                                __wbFAQUpdateIndex ( $wbFAQCatFile, $args );
                            }

                        }

                        if ( ! isset( $args['del'] ) )
                        {
                            $order = ( empty($args['order']) ) ? $matches[1] : $args['order'];
                            eval( $eval );
                            $lines[] = $newline;
                        }
                        // line will be deleted if $args['del'] ist set

                        continue;
                    }

                    $lines[] = $line;

                    if ( preg_match( "{^::(\d+)::$group::$cat::}", $line, $matches ) )
                    {
                        $i++;
                    }



                }
            }
        }

        if ( empty( $found ) ) {
            //$order   = ( empty($order) ) ? $i : $order;
            $order = ( empty($args['order']) ) ? ($i+1) : $args['order'];
            eval( $eval );
            $lines[] = $newline;
        }

        if ( true === $debug ) {
            echo "<pre>";
            print_r($lines);
            echo "</pre>";
        }

        rewind( $handle );
        fwrite( $handle, implode( '', $lines ) );
        ftruncate( $handle, ftell( $handle ) );

        fclose( $handle );
        fixperms( $file );

    }

}   // function __wbFAQUpdateIndex

/***********************************************************************
 * __wbFAQSortIndex - sort index entries
 */
function __wbFAQSortIndex ( $group = '', $cat = '', $id = 1 )
{
    global $wbFAQIndexFile;

    if ( $group == '' )
    {
        $pieces = preg_split( "/\.|\//", $pagename);
        $group  = $pieces[0];
    }

    $find_page;
    $new_id;
    $changes = array();

    if ( ! empty ( $_REQUEST['up'] ) )
    {
        $find_page = $_REQUEST['up'];
        $new_id    = $id - 1;
    }
    elseif ( ! empty ( $_REQUEST['down'] ) )
    {
        $find_page = $_REQUEST['down'];
        $new_id    = $id + 1;
    }
    else
    {
        return;
    }

    $pages = __wbFAQReadIndex( $group, $cat );

    while ( list ( $index, $item ) = each( $pages ) )
    {
        if ( $item[4] === $find_page )
        {
            $changes[$index] = $new_id;
        }
        elseif ( $item[1] == $new_id )
        {
            $changes[$index] = $id;
        }
    }

    while ( list ( $index, $id ) = each( $changes ) )
    {
        $args = array(
            group    => $group,
            cat      => $cat,
            page     => $pages[$index][4],
            question => $pages[$index][5],
            order    => $id
        );
        __wbFAQUpdateIndex ( $wbFAQIndexFile, $args );
    }

}   // function __wbFAQSortIndex


/***********************************************************************
 * __wbFAQHandleDelete - delete FAQ page
 */
function __wbFAQHandleDelete ( $pagename, $auth='delete' )
{
    global $WikiDir, $LastModFile;
    $WikiDir->delete($pagename);
    if ($LastModFile) { touch($LastModFile); fixperms($LastModFile); }
}   // function __wbFAQHandleDelete


/***********************************************************************
 * __sort2d - sorting
 */
function __sort2d ($array, $index, $order='asc', $natsort=FALSE, $case_sensitive=FALSE)
{
    if(is_array($array) && count($array)>0)
    {
         foreach(array_keys($array) as $key)
         {
             $temp[$key]=$array[$key][$index];
         }
         if(!$natsort)
         {
             ($order=='asc')? asort($temp) : arsort($temp);
         }
         else
         {
             ($case_sensitive)? natsort($temp) : natcasesort($temp);
             if($order!='asc')
             {
                 $temp=array_reverse($temp,TRUE);
             }
         }
         foreach(array_keys($temp) as $key)
         {
             (is_numeric($key))? $sorted[]=$array[$key] : $sorted[$key]=$array[$key];
         }
         return $sorted;
    }
    return $array;
}   // function __sort2d


/***********************************************************************
 * __wbFAQToggleLink - create "to top" link with javascript
 */
function __wbFAQToggleLink ( $anchor, $id, $action, $linktext, $title = NULL, $target = '_self' )
{
    global $lshow, $lhide;
    return Keep( "<a href=\"$anchor\" title=\"$title\" target=\"$target\" onclick=\"javascript:toggleObj('$id','$action','$lshow','$lhide','',0,'');return true;\">"
               . "$linktext</a>" );
}   // function __wbFAQToggleLink


/***********************************************************************
 * __wbFAQEditCat - edit categories
 */
function __wbFAQEditCat ( $pagename, $categories, $group, $args ) {

    global $wbFAQCatFile,
           $PubDirUrl;

    $return = array();

    if ( isset( $_REQUEST['id'] ) )
    {

        if ( isset( $_REQUEST['delcat'] ) )
        {
            $args = array(
                group    => $group,
                cat      => $_REQUEST['delcat'],
                del      => 1
            );
            __wbFAQUpdateIndex ( $wbFAQCatFile, $args );
        }
        else
        {
            __wbFAQSortCatIndex();
        }
        $categories = __sort2d( __wbFAQReadCategories( $group ), 1, 'asc', true );
    }

    array_push(
        $return,
        "(:table class=wbfaq:)\n"
    );

    foreach ( $categories as $thiscat )
    {
        array_push(
            $return,
            "(:cellnr:)[[$pagename?action=wbfaqadmin&_faq_action=editcat&group=$thiscat[2]&id=$thiscat[1]&up=".urlencode($thiscat[3])."|$PubDirUrl/arrow_up.png]]\n",
            "(:cell:)[[$pagename?action=wbfaqadmin&_faq_action=editcat&group=$thiscat[2]&id=$thiscat[1]&down=".urlencode($thiscat[3])."|$PubDirUrl/arrow_down.png]]\n",
            "(:cell:)[[$pagename?action=wbfaqadmin&_faq_action=editcat&group=$thiscat[2]&id=$thiscat[1]&delcat=".urlencode($thiscat[3])."|$PubDirUrl/delete.png]]\n",
            "(:cell:)$thiscat[3]\n"
        );

    }

    array_push(
        $return,
        "(:cellnr colspan=4 align=right:)\n\n",
        "(:input form action={\$PageUrl}:)\n",
        "(:input hidden action wbfaqadmin:)\n",
        "(:input hidden _faq_action editcat:)\n",
        "(:input hidden _faq_group $group:)\n",
        "(:input hidden _faq_addcat 1:)\n",
        "(:input submit name=post value=\"$[Add category]\" class=wbfaqbutton:)\n",
        "(:input end:)\n",
        "(:tableend:)\n"
    );

    return ( $return );
}   // end function __wbFAQEditCat()


/***********************************************************************
 * __wbFAQEditEntries - edit FAQ entries
 */
function __wbFAQEditEntries( $pagename, $group, $categories, $args, $auth ) {

    global $wbFAQIndexFile,
           $PubDirUrl;

    $cat    = $_REQUEST['_faq_category'];
    $span   = 6;
    $return = array();

    // delete entry
    if ( isset( $_REQUEST['del'] ) )
    {
        __wbFAQHandleDelete( $_REQUEST['del'], $auth );
        $args = array(
            group    => $group,
            cat      => $cat,
            page     => $_REQUEST['del'],
            del      => 1
        );
        __wbFAQUpdateIndex ( $wbFAQIndexFile, $args );
    }

    array_push(
        $return,
        "(:table class=wbfaq:)\n",
        "(:cellnr colspan=$span:)(:input form action={\$PageUrl}:)\n",
        "(:input hidden action wbfaqadmin:)\n",
        "(:input hidden _faq_action 1:)\n",
        "(:input hidden _faq_group $group:)\n",
        "\$[Category]: "
    );

    if ( empty ( $cat ) )
    {
        $cat = $categories[0][3];
    }

    foreach ( $categories as $thiscat )
    {
        // get faqs in this category
        $faqs     = __wbFAQReadIndex( $group, $thiscat[3] );
        $return[] = "(:input select name=_faq_category value=\"$thiscat[3]\" label=\"$thiscat[3] (".count($faqs).")\" onchange=\"submit();return true;\":)\n";
    }

    array_push(
        $return,
        "(:input submit name=post value=\">>\" class=wbfaqbutton:)\n",
        "(:input end:)\n",
        "(:cellnr colspan=$span:)\n\n",
        "(:cellnr colspan=$span class=wbhead:)'''$cat'''\n",
        "(:cellnr colspan=$span:)\n\n"
    );

    // move entry
    if ( isset( $_REQUEST['move'] ) ) {

        if ( ! isset( $_REQUEST['destgroup'] ) ) {

            array_push(
                $return,
                "(:input form action={\$PageUrl}:)\n",
                "(:input hidden action wbfaqadmin:)\n",
                "(:input hidden _faq_group $group:)\n",
                "(:input hidden _faq_action 1:)\n",
                "(:input hidden move ".$_REQUEST['move'].":)\n"
            );

            array_push(
                $return,
                "(:cellnr colspan=$span:)$[move entry to page group]:"
            );

            $groups = __wbFAQGetGroups();
            while ( list( $groupname, $count ) = each ( $groups ) ) {
                array_push(
                    $return,
                    "(:input select name=destgroup value=\"$groupname\" label=\"$groupname\":)\n"
                );
            }

            array_push(
                $return,
                "(:input submit name=post value=\"$[move]\" class=wbfaqbutton:)\\\\\n",
                "(:input end:)\n"
            );

        }
        else {

            // new group = old group?
            if ( $group !== $_REQUEST['destgroup'] ) {

                // move to new group
                $args = array(
                    group    => $group,
                    newgroup => $_REQUEST['destgroup'],
                    move     => $_REQUEST['move'],
                );
                __wbFAQUpdateIndex ( $wbFAQIndexFile, $args );

            }

        }

    }


    if ( isset( $_REQUEST['id'] ) )
    {
        __wbFAQSortIndex( $group, $cat, $_REQUEST['id'] );
    }

    $pages = __wbFAQReadIndex( $group, $cat );

    if ( is_array( $pages ) ) {

        // sort by "order"
        $pages = __sort2d( $pages, 1, 'asc' );

        foreach ( $pages as $page )
        {

            $content = $page[5];
            if ( $page[4] === $_REQUEST['move'] ) {

                array_push(
                    $return,
                    "(:cellnr colspan=".($span-1).":)\n",
                    "(:cell:)%tomove%$page[5]\n"
                );

            }
            else {

                array_push(
                    $return,
                    "(:cellnr:)[[$pagename?action=wbfaqadmin&amp;_faq_action=&amp;_faq_category=".urlencode($cat)."&id=$page[1]&up=".urlencode($page[4])."|$PubDirUrl/arrow_up.png\"$[up]\"]]\n",
                    "(:cell:)[[$pagename?action=wbfaqadmin&amp;_faq_action=&amp;_faq_category=".urlencode($cat)."&id=$page[1]&down=".urlencode($page[4])."|$PubDirUrl/arrow_down.png\"$[down]\"]]\n",
                    "(:cell:)[[$pagename?action=wbfaqadmin&amp;_faq_action=&amp;_faq_category=".urlencode($cat)."&del=".urlencode($page[4])."|$PubDirUrl/delete.png\"$[delete]\"]]\n",
                    "(:cell:)[[$pagename?action=wbfaqadmin&amp;_faq_action=&amp;_faq_category=".urlencode($cat)."&amp;move=".urlencode($page[4])."|$PubDirUrl/move.png\"$[move]\"]]\n",
                    "(:cell:)[[$page[4] | $PubDirUrl/edit.png\"$[edit]\"]]\n",
                    "(:cell:)$page[5]\n"
                );

            }

        }

    }

    array_push(
        $return,
        "(:cellnr colspan=$span:)",
        "(:input form action={\$PageUrl}:)\n",
        "(:input hidden action wbfaqadmin:)\n",
        "(:input hidden _faq_action addentry:)\n",
        "(:input hidden _faq_group $group:)",
        "(:input submit name=post value=\"+\" class=wbfaqbutton:)\n",
        "(:input end:)\n"
    );

    $return[] = "(:tableend:)\n";

    // add faq input form

    // category select
    $categories = __wbFAQReadCategories( $group );

    $output = '<select name="_faq_category">';
    foreach ( $categories as $cat )
    {
        $output .= "<option value=\"$cat[3]\">$cat[3]</option>";
    }
    $FmtPV['$wbFAQCategories'] = Keep( $output . '</select>' );

    $page = ReadPage( $wbFAQEditForm );
    $return[] = $page['text'];

    return ( $return );

}

function __wbFAQGetGroups () {

    $list   = __wbFAQReadCategories( '.*' );

    $groups = array();
    foreach ( $list as $item ) {
        $groups[ $item[2] ]++;
    }

    return $groups;

}

?>
